<id>
Anguz:FasterParsecode
</id>

<version>
1.08-9
</version>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// UBBC
	if($ubbc){
</search for>

<add before>
	$message = strtr($message, array('$' => '&#036;'));

</add before>

<search for>
			// A named email address. [email=me@some.place.com]me[/email]
			if(isset($add['[email='])){
				$arr1[] = '~\[email=(.+?)\](.+?)\[/email\]~ie';
				$arr2[] = isset($disabled['email']) ? '$2 ($1)' : '\'<a href="mailto:$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
</search for>

<replace>
			// A named email address. [email=me@some.place.com]me[/email]  And, you can't have []s in your email, I should know.
			if(isset($add['[email='])){
				$arr1[] = '~\[email=(.+?)\](.+?)\[/email\]~ie';
				$arr2[] = isset($disabled['email']) ? '"$2 ($1)"' : '"<a href=\"mailto:" . strtr("$1", array("\"" => "&quot;", "]" => "", "[" => "")) . "\">" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\])~i", "", strtr("$2", array("@" => "&#64;"))) . "</a>"';
			}
			// An image.  Width and height can be are optional.
			if(isset($add['[img]']) || isset($add['[img '])){
				$arr1[] = '~\[img(\s+width=([\d]+))?(\s+height=([\d]+))?\s*\](?:<br />)*(.+?)(?:<br />)*\[/img\]~ie';
				$arr2[] = isset($disabled['img']) ? 'preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$5", array("@" => "&#64;")))' : '"<img src=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$5", array("@" => "&#64;", "\"" => "&quot;"))) . "\" alt=\"\"" . ("$2" != "" ? " width=\"$2\"" : "") . ("$4" != "" ? " height=\"$4\"" : "") . " border=\"0\" />"';
</replace>

<search for>
			// Find an inside link. (named?) ie. [iurl]www.simplemachines.org[/iurl]
			if(isset($add['[iurl='])){
				$arr1[] = '~\[iurl=([^\]]+?)\]([^\[\]]+?)\[/iurl\]~i';
				$arr1[] = '~\[iurl=(.+?)\](.+?)\[/iurl\]~ie';
				if(isset($disabled['iurl'])){
					if(isset($disabled['url'])){
						$arr2[] = '$2 ($1)';
						$arr2[] = 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'';
					}else{
						$arr2[] = '<a href="$1" target="_blank">$2</a>';
						$arr2[] = '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
					}
				}else{
					$arr2[] = '<a href="$1">$2</a>';
					$arr2[] = '\'<a href="$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
				}
</search for>

<replace>
			// Find an inside link. (named?) ie. [iurl]www.simplemachines.org[/iurl]
			if(isset($add['[iurl='])){
				$arr1[] = '~\[iurl=(.+?)\](.+?)\[/iurl\]~ie';
				$arr2[] = isset($disabled['iurl']) ? (!isset($disabled['url']) ? '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$2", array("@" => "&#64;"))) . "</a>"' : 'preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", "$2") . " ($1)"') : '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\">" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$2", array("@" => "&#64;"))) . "</a>"';
</replace>

<search for>
				$arr1[] = '~\[iurl\](.+?)\[/iurl\]~i';
				$arr2[] = isset($disabled['iurl']) ? (isset($disabled['url']) ? '$1' : '<a href="$1" target="_blank">$1</a>') : '<a href="$1">$1</a>';
</search for>

<replace>
				$arr1[] = '~\[iurl\](.+?)\[/iurl\]~ie';
				$arr2[] = isset($disabled['iurl']) ? (!isset($disabled['url']) ? '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">$1</a>"' : '"$1"') : '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[iurl.*?\]|\[/iurl\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\">$1</a>"';
</replace>

<search for>
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$1\')' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$1\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
</search for>

<replace>
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", "$1")' : '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array("@" => "&#64;"))) . "</a>"';
</replace>

<search for>
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
</search for>

<replace>
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", "$2") . " ($1)"' : '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">" . preg_replace("~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$2", array("@" => "&#64;"))) . "</a>"';
</replace>

<search for>
				$arr1[] = '~\[url=([^\]]+?)\]([^\]]*?\[url(?:=[^\]]+?)?\].+?\[/url\].*?)\[/url\]~ie';
				$arr1[] = '~\[url=(.+?)\](.+?)\[/url\]~ie';
				if(isset($disabled['url'])){
					$arr2[] = 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'';
					$arr2[] = '\'$2 ($1)\'';
				}else{
					$arr2[] = '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
					$arr2[] = '\'<a href="$1" target="_blank">\' . strtr(\'$2\', array(\'@\' => \'&#64;\')) . \'</a>\'';
</search for>

<replace>
				$arr1[] = '~\[url=([^:\]]+?)\]([^\]]*?\[url(?:=[^\]]+?)?\].+?\[/url\].*?)\[/url\]~ie';
				$arr1[] = '~\[url=(.+?)\](.+?)\[/url\]~ie';
				if(isset($disabled['url'])){
					$arr2[] = 'preg_replace("~(\[url.*?\]|\[/url\])~i", "", "$2") . " ($1)"';
					$arr2[] = '"$2 ($1)"';
				}else{
					$arr2[] = '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">" . preg_replace("~(\[url.*?\]|\[/url\])~i", "", strtr("$2", array("@" => "&#64;"))) . "</a>"';
					$arr2[] = '"<a href=\"" . preg_replace("~(\[url.*?\]|\[/url\]|\[img.*?\]|\[/img\]|\[email.*?\]|\[/email\])~i", "", strtr("$1", array(":" => "&#58;", "\"" => "&quot;"))) . "\" target=\"_blank\">" . strtr("$2", array("@" => "&#64;")) . "</a>"';
</replace>

<search for>
			// An image.  Width and height can be are optional.
			if(isset($add['[img]']) || isset($add['[img '])){
				$arr1[] = '~\[img(\s+width=([\d]+))?(\s+height=([\d]+))?\s*\](?:<br />)*(.+?)(?:<br />)*\[/img\]~ei';
				$arr2[] = isset($disabled['img']) ? '$5' : '\'<img src="$5" alt=""\' . (\'$2\' != \'\' ? \' width="$2"\' : \'\') . (\'$4\' != \'\' ? \' height="$4"\' : \'\') . \' border="0" />\'';
			}
			// Size the font.  [size=large]HELLO![/size]
</search for>

<replace>
			// Size the font.  [size=large]HELLO![/size]
</replace>

<search for>
				$arr1[] = '~\[email\](?:<br />)*(.+?)(?:<br />)*\[/email\]~i';
				$arr2[] = isset($disabled['email']) ? '$1' : '<a href="mailto:$1">$1</a>';
</search for>

<replace>
				$arr1[] = '~\[email\](?:<br />)*(.+?)(?:<br />)*\[/email\]~ie';
				$arr2[] = isset($disabled['email']) ? '"$1"' : '"<a href=\"mailto:" . strtr("$1", array(":" => "&#58;", "\"" => "&quot;", "[" => "", "]" => "")) . "\">$1</a>"';
</replace>

<search for>
			// Acronyms and abbreviations... [acronym=Bulletin Board Code]BBC[/acronym]
			if(isset($add['[acronym='])){
				$arr1[] = '~\[acronym=((?:&quot;)?)(.+?)\\1\](.+?)\[/\\1\]~i';
				$arr2[] = isset($disabled['acronym']) ? '$3' : '<acronym title="$2">$3</$1>';
			}
			if(isset($add['[abbr='])){
				$arr1[] = '~\[abbr=((?:&quot;)?)(.+?)\\1\](.+?)\[/\\1\]~i';
				$arr2[] = isset($disabled['abbr']) ? '$3' : '<abbr title="$2">$3</$1>';
			}
</search for>

<replace>
			// Acronyms and abbreviations... [acronym=Bulletin Board Code]BBC[/acronym]
			if(isset($add['[abbr='])){
				$arr1[] = '~\[abbr=((?:&quot;)?)(.+?)\\1\](.+?)\[/abbr\]~ie';
				$arr2[] = isset($disabled['abbr']) ? '"$3 ($2)"' : '"<abbr title=\"" . strtr("$2", array("\"" => "&quot;")) . "\">$3</abbr>"';
			}
			if(isset($add['[acronym='])){
				$arr1[] = '~\[acronym=((?:&quot;)?)(.+?)\\1\](.+?)\[/acronym\]~ie';
				$arr2[] = isset($disabled['acronym']) ? '"$3 ($2)"' : '"<acronym title=\"" . strtr("$2", array("\"" => "&quot;")) . "\">$3</acronym>"';
			}
</replace>

<search for>
			// Handle flash.
			if(isset($add['[flash='])){
				$arr1[] = '~\[flash=(\d+),(\d+)\](?:<br />)*([^<>]+?)(?:<br />)*\[/flash\]~i';
				if(empty($modSettings['enableEmbeddedFlash']) || isset($disabled['flash']))
					$arr2[] = isset($disabled['url']) ? '$3' : '<a href="$3" target="_blank">$3</a>';
				else
					$arr2[] = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3" /><param name="play" value="true" /><param name="loop" value="true" /><param name="quality" value="high" /><param name="AllowScriptAccess" value="never" /><embed src="$3" width="$1" height="$2" play="true" loop="true" quality="high" AllowScriptAccess="never"></embed></object>';
</search for>

<replace>
			// Handle flash.
			if(isset($add['[flash='])){
				$arr1[] = '~\[flash=(\d+),(\d+)\](?:<br />)*([^<>]+?)(?:<br />)*\[/flash\]~ie';
				if (empty($modSettings['enableEmbeddedFlash']) || isset($disabled['flash']))
					$arr2[] = isset($disabled['url']) ? '"$3"' : '"<a href=\"" . strtr("$3", array("\"" => "&quot;")) . "\" target=\"_blank\">$3</a>"';
				// Internet Explorer for Windows.
				elseif ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'])
					$arr2[] = '"<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\"$1\" height=\"$2\"><param name=\"movie\" value=\"" . strtr("$3", array("\"" => "&quot;")) . "\" /><param name=\"play\" value=\"true\" /><param name=\"loop\" value=\"true\" /><param name=\"quality\" value=\"high\" /><param name=\"AllowScriptAccess\" value=\"never\" /><embed src=\"" . strtr("$3", array("\"" => "&quot;")) . "\" width=\"$1\" height=\"$2\" play=\"true\" loop=\"true\" quality=\"high\" AllowScriptAccess=\"never\" /><noembed><a href=\"" . strtr("$3", array("\"" => "&quot;")) . "\" target=\"_blank\">$3</a></noembed></object>"';
				// Anything else.
				else
					$arr2[] = '"<embed type=\"application/x-shockwave-flash\" src=\"" . strtr("$3", array("\"" => "&quot;")) . "\" width=\"$1\" height=\"$2\" play=\"true\" loop=\"true\" quality=\"high\" AllowScriptAccess=\"never\" /><noembed><a href=\"" . strtr("$3", array("\"" => "&quot;")) . "\" target=\"_blank\">$3</a></noembed>"';
</replace>
